# Generated by go2rpm
%bcond_without check

%global min_llvm 14
%if %{fedora} >= 37
%global max_llvm 15
%else
%global max_llvm 14
%endif

# https://github.com/tinygo-org/go-llvm
%global goipath         tinygo.org/x/go-llvm
%global forgeurl        https://github.com/tinygo-org/go-llvm
%global commit          dcb078a262665943160fa7b6a8dd219c2e2fc990

%gometa

%global common_description %{expand:
This library provides bindings to a system-installed LLVM.}

%global golicenses      LICENSE.txt
%global godocs          README.markdown

Name:           %{goname}
Version:        0
Release:        %autorelease -p
Summary:        Go bindings to a system-installed LLVM

License:        ASL 2.0 and NCSA
URL:            %{gourl}
Source0:        %{gosource}
# Fedora specific
Patch0001:      0001-Make-LLVM-config-file-architecture-independent.patch

BuildRequires:  gcc-c++
BuildRequires:  make
%{lua:
local llvm_supported_versions = 'llvm_supported_versions'
for version=tonumber(rpm.expand('%min_llvm')),tonumber(rpm.expand('%max_llvm')) do
  print('BuildRequires: llvm-devel(major) = ' .. version .. '\n')
  llvm_supported_versions = llvm_supported_versions .. ' ' .. version
end
rpm.define(llvm_supported_versions)
}

%description
%{common_description}

%gopkg

%prep
%goprep
%autopatch -p1

# Set current LLVM paths.
rm llvm_config*.go
for version in %{llvm_supported_versions}; do
    # Extra checks because of https://bugzilla.redhat.com/show_bug.cgi?id=1871659
    if type llvm-config-${version}-%{__isa_bits}; then
        make config VERSION=${version}.0.0 CONFIG=llvm-config-${version}-%{__isa_bits} BUILDDIR=%{_prefix}
    elif type llvm-config-${version}; then
        make config VERSION=${version}.0.0 CONFIG=llvm-config-${version} BUILDDIR=%{_prefix}
    elif type llvm-config-%{__isa_bits}; then
        make config VERSION=${version}.0.0 CONFIG=llvm-config-%{__isa_bits} BUILDDIR=%{_prefix}
    elif type llvm-config; then
        make config VERSION=${version}.0.0 CONFIG=llvm-config BUILDDIR=%{_prefix}
    else
        echo "Unable to determine llvm-config for LLVM ${version}"
        exit 1
    fi
    mv llvm_config_linux.go llvm_config_linux_llvm${version}.go
done

%install
%gopkginstall

%if %{with check}
%global gotestflags %gocompilerflags -tags="${TAGS}"
%check
for version in %{llvm_supported_versions}; do
export TAGS=llvm${version}
%gocheck
done
%endif

%gopkgfiles

%changelog
%autochangelog
